 	
	.include	"basic_vu.i"
	.include	"spad.i"
	.include	"demu.i"
	.include	"vumacros.m"

 	--enter
	--endenter
	
	iaddiu		us_up_p,vi00,sp_sizeof
	iaddiu		us_fi_p,vi00,sp_fishTable
	

up2_outer_loop:

	; load up my info

	lq		us_pos,fi_pos(us_fi_p)	
	lq		us_ahead,fi_ahead(us_fi_p)	

	lq		us_update,0(us_up_p)

	lq		forceVals,sp_forceVals(vi00)
	lq		cosRcpVals,sp_cosRcpVals(vi00)
	lq		cosMinVals,sp_cosMinVals(vi00)
	lq		distMinVals,sp_distMinVals(vi00)
	lq		distRcpVals,sp_distRcpVals(vi00)

	max		ONE,vf00,vf00[w]


	iaddiu		them_up_p,us_up_p,1
	iaddiu		them_fi_p,us_fi_p,fi_sizeof

	loi		0x7fffffff

up2_inner_loop:
	--LoopCS	1,0
	; load up their info

	lq		them_pos,fi_pos(them_fi_p)
	lq		them_ahead,fi_ahead(them_fi_p)
	lq		them_update,0(them_up_p)
		
	; so let's start processing this..

	// vsub_xyz( &vThem, &fi_them->pos,&fi_us->pos);  // from us to them
	sub.xyz		vThem,them_pos,us_pos

	
	
	// vnormlen(&nThem,&vThem);		// unit vector to them
	mul.xyz 	tmp,vThem,vThem
	move.xyz	nThem,vThem			; norm.xyz = vec
	mul.w		acc,vf00,tmp[x]
	madd.w 		acc,vf00,tmp[y]
	madd.w		nThem,vf00,tmp[z] 	; norm.w = |vec|^2
	rsqrt		q,vf00[w],nThem[w]  	
	mul		nThem,nThem,q			; norm.w= |vec|

	// float adot = vdot_xyz( &fi_us->ahead, &nThem);
	mul.xyz		tmp,us_ahead,nThem
	adda.x		acc,tmp,tmp[y]	
	madd.x		dot,ONE,tmp[z]

	
	// vmuli_xyz( &cos_vals, &cSPAD->cosRcpVals, adot );
	mul.xyz		acc,cosRcpVals,dot[x]

	// vadd_xyz( & cos_vals, &cos_vals, & cSPAD->cosMinVals); 
	madd.xyz	cos_vals,cosMinVals,vf00[w]

	
	
	// vclamp0_xyz( &cos_vals,&cos_vals);
	max.xyz		cos_vals,cos_vals,vf00

			
	// vsubi_xyz( &sca_vec,&cSPAD->distMinVals , nThem.w);
	sub.xyz		sca_vec,distMinVals,nThem[w]
	
	//vmul_z( &sca_vec,&sca_vec,&sca_vec);
	mul.z		sca_vec,sca_vec,sca_vec

	
	//vmul_xyz(&sca_vec,&sca_vec,&cSPAD->distRcpVals);
	mul.xyz		sca_vec,sca_vec,distRcpVals
	
	//sca_vec.z+=1.0;
	add.z		sca_vec,sca_vec,vf00[w]

	
	//vclamp0_xyz( &sca_vec,&sca_vec);
	max.xyz		sca_vec,sca_vec,vf00


	//vmul_xyz(&flk_vec,&sca_vec,&cos_vals);
	mul.xyz		flk_vec,sca_vec,cos_vals



	//vstep1_xyz(&inc_vec,&flk_vec);
	mul.xyz		inc_vec,flk_vec,i
	mini.xyz  	inc_vec,inc_vec,vf00[w]


 
 	// separation
	//vmuli_xyz(&sep,&nThem,flk_vec.x);
	mul.xyz		sep,nThem,flk_vec[x]
	
	//vsub_xyz(&updateBuffer[n],&updateBuffer[n],&sep);
	sub.xyz     	us_update,us_update,sep
	
	//vadd_xyz(&updateBuffer[m],&updateBuffer[m],&sep);
	add.xyz		them_update,them_update,sep
			


	// aligment

	//vmuli_xyz( &alg0,&fi_them->ahead,fi_them->ahead.w);
	mul.xyz	alg0,them_ahead,them_ahead[w]

	//	vmuli_xyz( &alg1,&fi_us->ahead,fi_us->ahead.w);
	mul.xyz	alg1,us_ahead,us_ahead[w]
		   	
	// vmuli_xyz( &alg0,&alg0,flk_vec.y);
	mul.xyz	alg0,alg0,flk_vec[y]
   	
	// vadd_xyz(&updateBuffer[n],&updateBuffer[n],&alg0);
	add.xyz us_update,us_update,alg0
		
	// vmuli_xyz( &alg1,&alg1,flk_vec.y);
	mul.xyz	alg1,alg1,flk_vec[y]
	
	// vadd_xyz(&updateBuffer[m],&updateBuffer[m],&alg1);
	add.xyz them_update,them_update,alg1
				
	 

			// coherence
	
	//vmuli_xyz(&coh,&nThem,flk_vec.z);
	mul.xyz	coh,nThem,flk_vec[z]

	//vadd_xyz(&updateBuffer[n],&updateBuffer[n],&coh);
	add.xyz	us_update,us_update,coh

	//vsub_xyz(&updateBuffer[m],&updateBuffer[m],&coh);
	sub.xyz	them_update,them_update,coh
			
			
			
	//float bAdd =  inc_vec.x+inc_vec.y+inc_vec.z;
	add.x		acc,inc_vec,inc_vec[y]
	madd.x		bAdd,ONE,inc_vec[z]		

	//updateBuffer[m].w+=bAdd;		 
	add.w		them_update,them_update,bAdd[x]
	
	//updateBuffer[n].w+=bAdd;		 
	add.w		us_update,us_update,bAdd[x]


	// save out their update, keep our update local

	sq		them_update,0(them_up_p)

	//fi_them++;
	iaddiu		them_fi_p,them_fi_p,fi_sizeof

	// next them update
	iaddiu		them_up_p,them_up_p,1

	// real end of the table
	iaddiu		end_them_fi_p,vi00,sp_fishTable+(NUM_FISH)*2
	
	// have they hit the end of the table
	ibne		them_fi_p,end_them_fi_p,up2_inner_loop		


	//vnormlen2(&org,&fi_us->pos);
	
	mul.xyz		tmp,us_pos,us_pos
	mul.w		acc,vf00,tmp[x]
	madd.w		acc,vf00,tmp[y]
	madd.w		org,vf00,tmp[z]
	move.xyz	org,us_pos
	rsqrt		q,vf00[w],org[w]
	
	mul.xyz		org,org,q

	//org.w=org.w*cSPAD->forceVals.w;
	mul.w		org,org,forceVals


	loi		0.75
	sub.w		org,org,i
	max.w		org,org,vf00[x]
	
	
	//float f=fi_us->pos.y;
	//	f=fabsf(f);
	abs.y		f,us_pos

	
	// f=f-cSPAD->distMinVals.w;
	sub.y	f,f,distMinVals[w]
	
	//if(f<0) f=0;
	max.y	f,f,vf00
	
	// f=f*cSPAD->distRcpVals.w;
	mul.y	f,f,distRcpVals[w]

	// updateBuffer[n].y*=(1-f);
	sub.y	f,ONE,f
	mul.y	us_update,us_update,f
		

	//	fVector	sep;
	// vmuli_xyz(&sep,&org,org.w);
	mul.xyz	sep,org,org[w]

	// vsub_xyz(&updateBuffer[n],&updateBuffer[n],&sep);
	sub.xyz	us_update,us_update,sep
	
	// updateBuffer[n].w++;
	add.w	us_update,us_update,vf00


	// save our update
	sq		us_update,0(us_up_p)

	// advance up
	iaddiu		us_fi_p,us_fi_p,fi_sizeof
	iaddiu		us_up_p,us_up_p,1

	// our end of the table
	iaddiu		end_us_fi_p,vi00,sp_fishTable+(NUM_FISH-1)*2

	// branch back if not done
	ibne		us_fi_p,end_us_fi_p,up2_outer_loop

	



	--exitm
	--endexit


